// FallDown -Classic- Version 1.01
// Main Program

// Created 08/04/2002; 21:47:40

#define USE_TI89              // Produce .89z File

// #define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include "sprites_fd.h"         

#define PIXOFFSET(x,y)  ((y<<5)-(y<<1)+(x>>3))
#define PIXADDR(p,x,y)  (((unsigned char*)(p))+PIXOFFSET(x,y))
#define PIXMASK(x)      ((unsigned char)(0x80 >> ((x)&7)))
#define GETPIX(p,x,y)   (!(!(*PIXADDR(p,x,y) & PIXMASK(x))))


/*Structure for saving highscores...*/

typedef struct
  {
    char name[10];
    unsigned long score;
  } HSC_ITEM;

/*Virtuals Screens*/
void *Vscreen = NULL;
void *Vscreen2 = NULL;


/*Function to input your name (thanks to Zeljko Juric with Cave Blaster...)*/
 void input_str(char *str)
{
ClrScr();
  int i=0,key=0;
    FontSetSys(F_8x10);
  DrawStr(10,10,"CONGRATULATIONS!",A_NORMAL);
  FontSetSys(F_6x8);
  DrawStr(10,30,"You are First!",A_NORMAL);
  DrawStr(10,50,"Enter Your Name:",A_NORMAL);
  
  while(key!=13)
    {
      str[i]='_'; str[i+1]=' '; str[i+2]=0;
      DrawStr(30,60,str,A_REPLACE);
      key=ngetchx();
      if(key>=' '&&key<='~'&&i<8) str[i++]=key;
      if(key==257&&i)
      {
      	
      	i--;
      }
}
str[i]=0;
}


/*Scrolling up Routine,thanks to Thomas Nussbaumer...*/
void ScrollUp(unsigned short* buffer,unsigned short lines) {
    register short* dest = buffer;
    register short* src  = dest + 15;
    register short  tmplines  = lines;
    tmplines-=2;
    asm volatile (
       "0:
        move.l (%0)+,(%1)+;move.l (%0)+,(%1)+;move.l (%0)+,(%1)+
        move.l (%0)+,(%1)+;move.l (%0)+,(%1)+;move.l (%0)+,(%1)+
        move.l (%0)+,(%1)+;move.w (%0)+,(%1)+
        dbra %2,0b
        clr.l (%1)+;clr.l (%1)+;clr.l (%1)+;clr.l (%1)+
        clr.l (%1)+;clr.l (%1)+;clr.l (%1)+;clr.w (%1)+"
        : "=a" (src), "=a" (dest), "=d" (tmplines)
        : "0"  (src),  "1" (dest), "2"  (tmplines));
}

/*Find the Hardware Version for adjusting speed (found in TIGCC help)*/
unsigned long GetHardwareVersion ()
{
  unsigned long hwpb, *rombase;
  rombase = (unsigned long *)((*(unsigned long *)0xC8) & 0x600000);
  hwpb = rombase[65];
  return (hwpb - (unsigned long)rombase  < 0x10000 &&
    *(unsigned short *)hwpb > 22 ? *(unsigned long *)(hwpb + 22) : 1);
}



/*Draw a new line of blocks with holes...*/
void drawblock(int h,int level_choice)
{
	int i,x1,x2,x3,x4;
	x1=random(10);
	x2=random(10);
	x3=random(10);
	x4=random(10);
	if (level_choice>0)
	x1=x2;
	if (level_choice>3)
	x3=x2;
		
	for (i=0;i<10;i++)
	if (i!=x1&&i!=x2&&i!=x3&&i!=x4)
	Sprite32(i*16,h,32,block,Vscreen,SPRT_OR);	
		
}

/*Check if the ball is on a block...*/

int  test(int x_ball,int y_ball,int height,int score)
{
if (y_ball+9==height||((score>0)&&(y_ball+9==height-50)))
 {
 	if (GETPIX(Vscreen,x_ball+3,y_ball+9)||GETPIX(Vscreen,x_ball+6,y_ball+9))
 	return 1;
 }
	return 0;
	
}


// Main Function
void _main(void)
{
/*Initial Highscores...*/
static HSC_ITEM bestscore[5]={{"David",10},{"David",10},
    {"David",10},{"David",10},{"David",10}};

 HSC_ITEM level[5]={{"Very Easy",20},{"Easy     ",15},{"Medium    ",11},
{"Hard     ",8},{"Very Hard",7}};

unsigned long hw=GetHardwareVersion ();

while(1)
{
int level_choice=0,i,key,score;
ClrScr();

/* Draw the 'Falldow' Title*/
BitmapPut(12,8,(BITMAP *)&(unsigned char[]){0,32,0,136,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xF8,0x00,0x00,0x3C,0x00,0x78,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x3F,0xF8,0x38,0x00,0x3E,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x3F,0x00,0x3C,0x00,0x3E,0x00,0x7C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x7E,0x00,0x3C,0x00,0x3C,0x00,0x78,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,0x60,0x30,0x7C,0x7C,0x00,0x3E,0x00,0x3C,0x00,0x78,0x00,0xFF,0x80,0x0F,0x00,0x00,0x00,0x70,0x73,0x78,0x78,0x00,0x7E,0x00,0x3C,0x00,0x78,0x00,0xFF,0x80,0x0F,0x80,0x00,0x00,0x70,0xF0,0x78,0x78,0x00,0x7F,0x00,0x38,0x00,0x70,0x00,0xF3,0xC0,0x3F,0x80,0x00,0x00,0xF0,0xF0,0x38,0x78,0x00,0x7F,0x00,0x38,0x00,0x70,0x00,0x71,0xC0,0x7F,0x00,0x00,0x00,0xE0,0xF0,0x38,0x78,0x00,0x77,0x00,0x38,0x00,0x70,0x00,0xF1,0xE0,0xFC,0x01,0xC0,0x01,0xE1,0xF8,0x38,0x78,0x00,0x67,0x80,0x38,0x00,0x70,0x00,0xFD,0xE3,0xF9,0xC1,0xC0,0x03,0xE1,0xF8,0x30,0x78,0x00,0xE7,0x80,0x38,0x00,0x70,0x0C,0xE0,0xE1,0xF1,0xE0,0xC0,0x03,0xE1,0xF8,0x70,0x78,0x00,0xE7,0x80,0xF0,0x01,0xE0,0x00,0xE0,0xE1,0xF0,0xF0,0xC1,0x81,0xC1,0xD8,0x70,0x7F,0xC0,0xE3,0x80,0x30,0x00,0x60,0x00,0xE0,0xE1,0xE0,0x70,0xC3,0xC3,0xC1,0xD8,0xE0,0x78,0x03,0xE3,0xC0,0x30,0x00,0x60,0x00,0xE0,0xE1,0xE0,0x78,0xC3,0xC7,0xC1,0xDC,0xE0,0x70,0x01,0xFB,0xC0,0x30,0x00,0x60,0x00,0xE0,0xE1,0xE0,0x78,0xC3,0xC7,0xC1,0xDD,0xC0,0x30,0x03,0xFF,0xFC,0x30,0x00,0x60,0x00,0xE0,0xE1,0xE0,0x78,0xC7,0xE7,0x81,0xCD,0xC0,0x30,0x03,0xFF,0xE0,0x30,0x30,0x60,0x60,0xC0,0xE1,0xF0,0xF8,0x66,0xE7,0x83,0x8D,0xC0,0x30,0x03,0xF8,0xE0,0x60,0x00,0xC0,0x01,0xC0,0xE1,0xF0,0xF0,0x66,0xFF,0x83,0x8D,0xC0,0x30,0x01,0xF0,0x60,0x60,0x00,0xC0,0x01,0xC1,0xC0,0xF8,0xF0,0x6C,0xFF,0x87,0x87,0x80,0x30,0x01,0xC0,0x70,0x60,0x1C,0xC0,0x39,0x81,0xC0,0x7F,0xE0,0x6C,0x7F,0x07,0x87,0x80,0x30,0x01,0xC0,0x30,0x61,0xFE,0xC3,0xFD,0x87,0x80,0x3F,0xE0,0x78,0x7F,0x07,0x87,0x80,0x30,0x03,0xC0,0x30,0x7F,0xFE,0xFF,0xFD,0x9F,0x00,0x0F,0x80,0x78,0x3E,0x03,0x87,0x80,0x30,0x0F,0xC0,0x18,0x7F,0xFC,0xFF,0xF9,0xFE,0x00,0x00,0x00,0x70,0x1E,0x00,0x03,0x00,0x30,0x07,0xC0,0x18,0x7F,0x80,0xFF,0x01,0x80,0x00,0x00,0x00,0x60,0x00,0x03,0x00,0x00,0x38,0x07,0xC0,0x0C,0x7E,0x00,0xFC,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x07,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x06,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
},&(SCR_RECT){{0,0,239,127}},A_REPLACE);

DrawStr(13,62,"Level :",A_NORMAL);
FontSetSys(F_8x10);
DrawStr(42,40,"-Classic-",A_NORMAL);

FontSetSys(F_4x6);
DrawStr(36,88,"2002 v 1.01 by David Coz",A_NORMAL);
DrawStr(41,94,"Coz.hubert@infonie.fr",A_NORMAL);

FontSetSys(F_6x8);

 while (key!=13)
{

DrawStr(60,62,level[level_choice].name,A_REPLACE);
DrawStr(13,73,"Best  :",A_NORMAL);
DrawStr(60,73,"               ",A_REPLACE);
DrawStr(110,73,bestscore[level_choice].name,A_NORMAL);
printf_xy(60,73,"%ld by",bestscore[level_choice].score);

key=ngetchx();
if (key==344)
{
level_choice++;
	if (level_choice==5)
level_choice=0;
}
if (key==338)
{
level_choice--;
	if (level_choice==-1)
level_choice=4;
}
if (key==264)
{
return;
}
}
restart:
score=0;

Vscreen = malloc(3840);       //Virtual Screen for the blocks
Vscreen2 = malloc(3840);      //Virtual Screen for the ball
memcpy(Vscreen,LCD_MEM, 3840);
randomize();
PortSet(Vscreen2, 239, 127);
ClrScr();

PortSet(Vscreen, 239, 127);


OSSetSR(0x0400);
int height=180,quit=1,j,speed,x_ball=60<<2,y_ball=0,old_x=60<<2,old_y=0;
// height is the Y value for the last appeared line of blocks... 

/*Adjuste Speed,depending on Level and Calc Hardware...*/

speed=level[level_choice].score;
speed*=(hw==2 ? 12 :10);

while(quit)
{
//Scroll the Virtual Screen with Blocks on it
ScrollUp(Vscreen,120);

//Decrease Height
height--;

// If height=99,it's time to draw a new line 
	if (height==99)
	{
	score++;
		drawblock(height,level_choice);
	}
	
	
if (height==50)
height=100;




if (_rowread(0x3F)&0x1)
	quit=0;

// if the ball is on the Block,the ball goes up,otherwise it goes down
if (test(x_ball>>2,y_ball>>2,height,score))
y_ball-=4;
else
y_ball+=4;

if ((y_ball>>2)>90)
y_ball=(90<<2);

//You loose !!!
if (y_ball<0)
quit=0;

//draw the Ball in Vscreen2,erase the previous ball position
memcpy(Vscreen2,Vscreen, 3840);

Sprite16(old_x>>2,(old_y>>2)-1,16,ball,Vscreen2,SPRT_XOR);
Sprite16(x_ball>>2,(y_ball>>2)-1,16,ball,Vscreen2,SPRT_OR);

memcpy(LCD_MEM, Vscreen2, 3840);
	
old_x=x_ball;
old_y=y_ball;

	
		if (_rowread(~((short)(1<<1))) & (1<<6))
		off();	
	
		if (_rowread(0x7E)&0x08&&x_ball>>2!=150)
		x_ball+=5;
		if (_rowread(0x7E)&0x02&&x_ball>>2!=0)
		x_ball-=5;
		

/*Waiting Loop...*/
for (i=0;i<speed*10;i++)
for (j=0;j<1000;j++)
{
	
}


}
/* Free Virtual Screens...*/
free(Vscreen);
free(Vscreen2);

PortRestore();

	FontSetSys(F_8x10);
	DrawStr(30,30,"GAME OVER",A_REPLACE);
	FontSetSys(F_6x8);

	DrawStr(20,50,"                       ",A_REPLACE);
printf_xy(20,50,"Your Score is :%d",score);
	key=0;
	while (key!=13&&key!=264)
	{
	key=ngetchx();
	} 
if (score>bestscore[level_choice].score)
{
input_str(bestscore[level_choice].name);
bestscore[level_choice].score=score;
}	
if (key==13)
goto restart;
}
	
}

// By David Coz     Coz.hubert@infonie.fr

